%%% Functors:     
    fun  penc/2.
    fun  pub/1.
    fun  h/1.
    fun  a/0.   % the honest users
    fun  b/0.    
    fun  c/0.   % the intruder
    fun  k/1.   % participant private keys

    % nonces
    fun  n/3. 
    fun  m/4. 

    fun end/1.

%%% Auxiliary predicates:
    part(a).
    part(b).
    part(c).

    talksA(a,b).
    talksA(a,c).
    talksA(b,a).
    talksA(b,c).

    talksB(b,a).
    talksB(b,c).
    talksB(a,c).
    talksB(a,b).
    
%%% RULES:

%%% Intruder rules

    rule  X, pub(K) -> penc(X,pub(K)).
    rule  penc(X,pub(K)), K -> X.
    rule  X -> h(X).

%%% Initial knowledge
    rule   A   :-  part(A).
    rule   pub(k(A)) :- part(A).
    rule   k(c).

%%% Rule (1):  [A -> B]   {NA, A}KB

    rule  penc((n(A,B,_I), A), pub(k(B)))
    :- talksA(A,B).

%%% Rule (2):  [B -> A]   {X, A}KB -> {MB, X+B}KA

    rule  penc((X, A), pub(k(B))) -> penc((m(B,A,I,X), h((X,m(B,A,I,X)))+B), pub(k(A)))
    :- talksB(B,A).

%%% Rule (3):  [A -> B]   {Y, NA+B}KA -> {Y}KB

    rule  begin((A,B,Y)), 
          penc((Y, h((n(A,B,_I),Y))+B), pub(k(A))) ->  penc(Y, pub(k(B)))  
    :- 
        talksA(A,B).

%%% Rule (4):

    rule  
        penc((X,a), pub(k(b))), 
        penc(m(b,a,I,X), pub(k(b))) 
            ->  end((a,b,m(b,a,I,X))).

%%% The goal:
    query end(_X).
