%%% Functors:
    fun  penc/2.
    fun  pub/1.
    fun  h/1.
    fun  a/0.   % the honest users
    fun  b/0.   % 
    fun  c/0.   % the intruder
    fun  k/1.   % participant private keys

    % nonces
    fun  n/3. 
    fun  m/4. 

    fun end/1.

%%% Auxiliary predicates:
    part(a).
    part(b).
    part(c).

    talksA(a,b).
    talksA(a,c).
    talksA(b,a).
    talksA(b,c).

    talksB(b,a).
    talksB(b,c).
    talksB(a,c).
    talksB(a,b).

%%% RULES:

%%% Intruder rules

    rule  X, pub(K) -> penc(X,K).
    rule  penc(X,K), K -> X.
    rule  X -> h(X).

%%% Initial knowledge
    rule   A   :-  part(A).
    rule   pub(k(A)) :- part(A).
    rule   k(c).

%%% Rule (1): 

    rule  penc((n(A,B,_I), A), k(B))
    :- talksA(A,B).

%%% Rule (2):

    rule    begin((B,A,X,m(B,A,I,X))),
            penc((X, A), k(B)) -> penc((m(B,A,I,X), X+B), k(A))
    :- talksB(B,A).

%%% Rule (3):

    rule  penc((Y, n(A,B,I)+B), k(A)) ->  
            penc(Y, k(B)),
            end((B,A,n(A,B,I),Y))
    :- 
        talksA(A,B).

%%% The goal:
    query end((b,a,_X,_Y)).
